/*	
 *	clipuvi.h
 *
 *	P/ECE Signetics 2637 UVI(Universal Video Interface) Emulator
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2005 Naoyuki Sawa
 *
 *	* Sat Apr 30 13:14:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_UVI_H__
#define __CLIP_UVI_H__

/****************************************************************************
 *
 ****************************************************************************/

/* UVI_ASMV{`ǂݍ݂܂B
 * UVI_ASMV{̖`/`ɂC/AZuR[h̐؂ւ́A
 * C\[Xt@C(*.c)ƃAZu\[Xt@C(*.s)QƂ̂ŁA
 * ʂ̃CN[ht@CɕĂ܂B
 * (CL̒`܂ރCN[ht@Ĉ܂܃AZu\[X
 *  CN[hƁAAZuG[ɂȂĂ܂߁B)
 */
#include "clipuvia.h"

/********** ȍ~͏Ȃł **********/

/* P/ECEȊOł̓AZuR[h͎gpł܂B
 */
#ifndef PIECE
#undef UVI_ASM
#endif /*PIECE*/

/****************************************************************************
 *	UVI (Universal Video Interface)
 ****************************************************************************/

//			  +++------------------------- TV picture width
//			  ||| +++--------------------- horizontalblank
//			  ||| |||   +++--------------- TV picture height
//			  ||| |||   ||| ++------------ vertical blank
//			  ||| |||   ||| || +---------- vertical sync
//			  ||| |||   ||| || |  ++------ 60 frames per second
//			  ||| |||   ||| || |  ||
//#define UVI_CLOCK	((128+100)*(208+51+3)*60)   /* NTSCUVIClock */
/* vŹ̒ʂłAۂNTSC Clocḱx߂ɐݒ肳Ă܂B */
#define UVI_CLOCK	NTSC_COLOR_SUBCARRIER
#define ARCADIA_CLOCK	UVI_CLOCK             /* NTSCARCADIA CPUClock */

#define UVIBUFLEN 320 /* =16000/50 c 1[tick](=1/50[sec])̃Tv */

#ifdef PIECE
#define UVI_GRAYSCALE
#endif /*PIECE*/

/*  */
/* AZu[`璼ڎQƂĂ̂ŁAtH[}bgŒłB */
/* tH[}bgύXƂ́Aframuvia.s̒`Ǐ]ĂB */
/*  */

typedef struct _UVIOBJ {
	unsigned char size;				/* + 0,1: TCY (0=W,1=c2{g) */
	unsigned char color;				/* + 1,1: J[ */
	short resv;					/* + 2,2: (\) */
	short x;					/* + 4,2: XW */
	short y;					/* + 6,2: YW */
	unsigned char* font/*[8]*/;			/* + 8,4: tHg */
} UVIOBJ;						/* =12 */
#define SIZEOF_UVIOBJ					    12

typedef struct _UVI {
	/*---------- Video ----------*/
	unsigned char* ram/*[0x400]*/;			/* +  0,  4: ORAMAWX^ */
	unsigned char* vbuff/*[128*208]*/;		/* +  4,  4: ݂̉z (NULL=`斳) */
	short scan_start;				/* +  8,  2: ÕXLCʒu (`ԏ[  ) */
	short scan_end;					/* + 10,  2: ݂̃XLCʒu (`ԉ[+1) */
	short scroll_x;					/* + 12,  2: XN[ */
	short scroll_y;					/* + 14,  2: XN[ */
	UVIOBJ obj[4];					/* + 16, 48: OBJ1,OBJ2,OBJ3,OBJ4 */
	unsigned char color[4/*B7:6*/][2/*Font*/];	/* + 64,  8: BGJ[ */
	unsigned char bg[16/*Col*/ * 26/*Row*/];	/* + 72,416: BG */
	unsigned char pot[4];				/* +488,  4: A/D Potentiometer */
	/*---------- Sound ----------*/
} UVI;							/* =492 */
#define SIZEOF_UVI					    492

/****************************************************************************
 *	O[oϐ
 ****************************************************************************/

extern UVI uvi;
extern unsigned char uvi_font[8/*Line*/ * 64/*Character*/ * 2/*Mode*/];

#ifdef UVI_GRAYSCALE
extern const unsigned char uvi_grayscale_table[8/*Color*/];
#else /*UVI_GRAYSCALE*/
extern const unsigned char uvi_color_table[8/*Color*/][3/*R,G,B*/];
#endif /*UVI_GRAYSCALE*/

/****************************************************************************
 *	֐
 ****************************************************************************/

void uvi_update_pot();
void uvi_update_color();
void uvi_partial_update();
void uvi_draw_chr_8x8(int x, int y, int code, const unsigned char* font);
void uvi_draw_chr_8x16(int x, int y, int code, const unsigned char* font);
void uvi_draw_obj_8x8(UVIOBJ* obj);
void uvi_draw_obj_8x16(UVIOBJ* obj);

/****************************************************************************
 *	AvP[Vp֐
 ****************************************************************************/

void uvi_reset(unsigned char* ram/*[0x400]*/);
int uvi_read(int addr);
void uvi_write(int addr, int data);
void uvi_set_pot(int pot, int data);
void uvi_new_frame(unsigned char* vbuff/*[128*208]*/);
void uvi_next_line();

#ifdef UVI_GRAYSCALE
/* 128x208x16~OCXP[A88x128x16~OCXP[֏kRs[܂B
 * [in]
 *	src		128x208x16~OCXP[ʃobt@B
 *	dst		 88x128x16~OCXP[ʃobt@B
 *
 * [note]
 *	* srcdst͓AhXwĂĂ\܂B
 *	  ŏII88x128̉ʃC[WKvȂ΁A128x20888x128̉ʃobt@ʉāA
 *	  ߖł܂B
 */
void uvi_reduce(unsigned char dst[/*88*128*/], const unsigned char src[/*128*208*/]);
#endif UVI_GRAYSCALE

#endif /*__CLIP_UVI_H__*/
